/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree.
 */

#pragma once

#include <flashlight/flashlight.h>

namespace w2l {

struct SpeechStats {
  intl totalInputSz_;
  intl totalTargetSz_;
  intl maxInputSz_;
  intl maxTargetSz_;
  intl numSamples_;

  SpeechStats();
  void reset();
  std::vector<intl> toArray();
};

class SpeechStatMeter {
 public:
  SpeechStatMeter();
  void add(const af::array& input, const af::array& target);
  void add(const SpeechStats& stats);
  std::vector<intl> value();
  void reset();

 private:
  SpeechStats stats_;
};
} // namespace w2l
